import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.Border;

import java.util.ArrayList;
import java.util.List;


public class LinkGraph extends JFrame {
	
	LinkTopicTermOverTime lttot = new LinkTopicTermOverTime();
	
	List<JTextArea> labelList = new ArrayList<JTextArea>();
	
	
	public void labelListGeneration() {
		for(int j=0; j<LinkTopicTermOverTime.NUM_OF_TOPICS; j++) {
			for(int i=0; i<LinkTopicTermOverTime.NUM_OF_TIME; i++) {
				TopicTerm tt = lttot.topicTermMatrixList.get(i).get(j);
				String str = "";
				String str1 = "";
				for(int k=0; k<tt.size(); k++) {
					str += tt.get(k);
					str += "\n";
					str1 += tt.get(k);
					str1 += "  ";
				}
				//System.out.println(str);
				Border border = BorderFactory.createLineBorder(Color.BLACK);
				JTextArea textArea = new JTextArea(10,10);
				if(lttot.reverseBitmap[j][i] != 0) {
					int r = lttot.reverseBitmap[j][i]*100%255;
					int g = lttot.reverseBitmap[j][i]*200%255;
					int b = lttot.reverseBitmap[j][i]*300%255;
					textArea.setBackground(new Color(r,g,b));
				}
				textArea.setText(str);
				textArea.setEditable(false);
				textArea.setBorder(border);
				textArea.setToolTipText(str1);
				labelList.add(textArea);
			}
		}
	}
	
	public void launchFrame() {
		this.setLocation(80, 6);
		this.setSize(1200, 720);
		this.setLayout(new GridLayout(20,12));
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		lttot.TopicTermMatrixListGeneration();
		lttot.link();
		lttot.createBitMap();
		labelListGeneration();
		for(int i=0; i<labelList.size(); i++) {
			this.add(labelList.get(i));
		}
		this.setVisible(true);
	}

	public static void main(String[] args) {
		new LinkGraph().launchFrame();

	}

}
