import java.util.*;
import java.io.*;

public class LinkTopicTermOverTime {
		
	public static final int NUM_OF_TIME = 12;
	
	public static final int NUM_OF_TOPICS = 20;
	
	public static final int THRESHOLD = 7;
	
	private int[][] bitmap = new int[NUM_OF_TIME][NUM_OF_TOPICS];
	
	public int[][] reverseBitmap = new int[NUM_OF_TOPICS][NUM_OF_TIME];
	
    List<TopicTermMatrix> topicTermMatrixList = new ArrayList<TopicTermMatrix>();
	
	public void TopicTermMatrixListGeneration() {
		for(int i=1; i<=NUM_OF_TIME; i++) {
			TopicTermMatrix ttm = new TopicTermMatrix();
			ttm.parse(new File("topic-terms\\topicterms2008-" + i + ".dat"));
			topicTermMatrixList.add(ttm);
		}
	}
	
	public void print() {
		for(int i=0; i<NUM_OF_TIME; i++) {
			System.out.println(i+1 + "");
			topicTermMatrixList.get(i).print();
		}
		System.out.println();
	}
	
	
	public void link() {
		for(int i=0; i<NUM_OF_TIME-1; i++) {
			for(int j=0; j<NUM_OF_TOPICS; j++) {
				TopicTerm tt = topicTermMatrixList.get(i).get(j);
				for(int k=0; k<NUM_OF_TOPICS; k++) {
					TopicTerm next = topicTermMatrixList.get(i+1).get(k);
					if(isShareThresholdOutOf10Terms(tt, next)) {
						tt.setNext(next);
						next.setPre(tt);
						break;
					}
				}
			}
		}
	}
	
	private boolean isShareThresholdOutOf10Terms(TopicTerm pre, TopicTerm next) {
		int count = 0;
		for(int i=0; i<pre.size(); i++) {
			String term = pre.get(i);
			for(int j=0; j<next.size(); j++) {
				if(term.equals(next.get(j))) {
					count++;
					break;
				}
			}
		}
		if(count >= THRESHOLD) {
			return true;
		} else {
			return false;
		}
	}
	
	public void createBitMap() {
		int key = 1;
		for(int i=0; i<NUM_OF_TIME; i++) {
			for(int j=0; j<NUM_OF_TOPICS; j++) {
				TopicTerm tt = topicTermMatrixList.get(i).get(j);
				tt.setBitmapX(i);
				tt.setBitmapY(j);
				if(tt.getPre() != null) {
					bitmap[i][j] = bitmap[tt.getPre().getBitmapX()][tt.getPre().getBitmapY()];
				} else if(tt.getNext() != null) {
					bitmap[i][j] = key++;
				} else {
					bitmap[i][j] = 0;
				}
			}
		}
		
		/*for(int i=0; i<NUM_OF_TIME; i++) {
			for(int j=0; j<NUM_OF_TOPICS; j++) {
				System.out.print(bitmap[i][j] + " ");
			}
			System.out.println();
		}*/
		
		for(int i=0; i<NUM_OF_TOPICS; i++) {
			for(int j=0; j<NUM_OF_TIME; j++) {
				reverseBitmap[i][j] = bitmap[j][i];
			}
		}
		
		for(int i=0; i<NUM_OF_TOPICS; i++) {
			for(int j=0; j<NUM_OF_TIME; j++) {
				System.out.print(reverseBitmap[i][j] + " ");
			}
			System.out.println();
		}
		
	}
	
	public void test() {
		int count1 = 0;
		int count2 = 0;
		for(int i=0; i<NUM_OF_TIME-1; i++) {
			for(int j=0; j<NUM_OF_TOPICS; j++) {
				if(topicTermMatrixList.get(i).get(j).getNext() != null) {
					count1++;
				}
				if(topicTermMatrixList.get(i).get(j).getPre() != null) {
					count2++;
				}
			}
		}
		System.out.println(count1 + "");
		System.out.println(count2 + "");
	}
	
	public static void main(String[] args) {
		LinkTopicTermOverTime lttot = new LinkTopicTermOverTime();
		lttot.TopicTermMatrixListGeneration();
		lttot.link();
		//lttot.test();
		//lttot.print();
		lttot.createBitMap();
	}

}
