import java.io.*;

public class DTMComputation {
	
	public void DynamicTopicModelsComputation() {
		rename();
		System.out.println("Dynamic Topic Models computation start!");
		try {
			String command = "DTM.bat " + ParamSetup.NUM_OF_TOPICS;
			Process process = Runtime.getRuntime().exec(command);
			System.out.println("Computing...Please wait for a long time!");
			BufferedReader br = new BufferedReader(new InputStreamReader(process.getInputStream()));
			new Thread(new ReadStandardOutput(br)).start();
			process.waitFor();
			process.getOutputStream().close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch(InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	/*
	 * prefix with test.
	 * Ҫĵĵǰ׺test.
	 */
	private void rename() {
		File documentsAfterPreProcessing = new File("DocumentsAfterPreProcessing.dat");
		File seq = new File("seq.dat");
		documentsAfterPreProcessing.renameTo(new File("test-mult.dat"));
		seq.renameTo(new File("test-seq.dat"));
	}
	
	private class ReadStandardOutput implements Runnable {
		private BufferedReader br;
		public ReadStandardOutput(BufferedReader br) {
			this.br = br;
		}
		public void run() {
			String s;
			try {
				while((s = br.readLine()) != null) {
					System.out.println(s);
				}
				br.close();
				System.out.println("Dynamic Topic Models computation finished!");
				System.out.println("===============================================================");
				//ǿݻ
				new StrengthEvolutionGeneration().generateStrengthEvolution();
				//ݻ
				new ContentEvolutionGeneration().generateContentEvolution();
			} catch(IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		new DTMComputation().DynamicTopicModelsComputation();
	}
}
