import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TimeSequenceDocGeneration {
		
	public static final String INPUT_FILE_DIR = "DocumentsAfterPreProcessing.dmap";
	
	public static final String OUTPUT_FILE_DIR = "seq.dat";
	
	private int[] numOfFileInEveryMonth = new int[ParamSetup.NUM_OF_TIME];
	
	public void generateTimeSequenceDoc() {
		System.out.println("Time sequence Doc generation start!");
		count(new File(INPUT_FILE_DIR));
		write(new File(OUTPUT_FILE_DIR));
		System.out.println("Time sequence Doc generation finished!");
		System.out.println("===============================================================");
	}

	
	public void count(File f) {
		int index = 0;
		int num = 1, preNum = 1;
		char[] ch;
		try {
			FileReader fr = new FileReader(f);
			BufferedReader br = new BufferedReader(fr);
			String s = null;
			while((s = br.readLine()) != null) {
				String temp = s.substring(33, 35);
				num = Integer.parseInt(temp);
				if(num == preNum) numOfFileInEveryMonth[index] ++;
				else {
					index++;
					numOfFileInEveryMonth[index] ++;
					preNum = num;
				}
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void write(File f) {
		try {
			FileWriter fw = new FileWriter(f);
			BufferedWriter bw = new BufferedWriter(fw);
			bw.write(ParamSetup.NUM_OF_TIME+"");
			bw.newLine();
			for(int i=0; i<numOfFileInEveryMonth.length; i++) {
				bw.write(numOfFileInEveryMonth[i]+"");
				bw.newLine();
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
